package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type DeleteSecurityGroupRuleLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewDeleteSecurityGroupRuleLogic(ctx context.Context, svcCtx *svc.ServiceContext) *DeleteSecurityGroupRuleLogic {
	return &DeleteSecurityGroupRuleLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *DeleteSecurityGroupRuleLogic) DeleteSecurityGroupRule(req *types.DeleteSecurityGroupRuleReq) (resp *types.DeleteSecurityGroupRuleResp, err error) {
	// todo: add your logic here and delete this line
	DeleteSecurityGroupRuleReq := &openstack.DeleteSecurityGroupRuleReq{}
	err = copier.CopyWithOption(DeleteSecurityGroupRuleReq, req, copier.Option{Converters: utils.Converters})
	DeleteSecurityGroupRuleResp, err := l.svcCtx.OpenstackRpc.DeleteSecurityGroupRule(l.ctx, DeleteSecurityGroupRuleReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&DeleteSecurityGroupRuleResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &DeleteSecurityGroupRuleResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
